<script setup lang="ts">
  import SwLink from '@/components/shared/atoms/SwLink.vue';

  const btnStylingMapping = {
    default:
      'relative transition select-none text-sm border border-gray-400 shadow rounded-md leading-none active:enabled:shadow-none disabled:(shadow-none cursor-not-allowed)',
    primary:
      'bg-primary border-primary text-white hover:enabled:(bg-primary-hover border-primary-hover) active:enabled:(bg-primary-pressed border-primary-pressed) disabled:(bg-primary-disabled border-primary-disabled)',
    action:
      'bg-interactive text-darkgray-600 md:hover:enabled:bg-interactive-hover active:enabled:bg-interactive-pressed disabled:text-information-disabled',
    danger:
      'text-white bg-crimson-500 border-crimson-500 hover:enabled:(bg-crimson-700 border-crimson-700) active:enabled:(bg-crimson-900 border-crimson-900) disabled:(bg-crimson-200 border-crimson-200)',
    'danger-outlined':
      'text-crimson-500 bg-crimson-50 border-crimson-500 hover:(border-crimson-700 color-crimson-700 bg-crimson-100) disabled:(bg-crimson-50/65 border-crimson-100 color-crimson-200)',
    fab: '!rounded-full md:h-12 md:w-12 h-11 w-11 p-0',
    loading: 'pointer-events-none opacity-80',
    small: 'py-1 px-2',
    medium: 'py-2 px-3 font-medium',
    large: 'py-2.5 px-4 font-semibold',
  };

  const slots = useSlots();
  const props = withDefaults(
    defineProps<{
      variant?: 'action' | 'primary' | 'danger' | 'danger-outlined';
      size?: 'small' | 'medium' | 'large';
      to?: string;
      fab?: boolean;
      loading?: boolean;
      badge?: string | number;
    }>(),
    {
      variant: 'primary',
      size: 'medium',
      badge: undefined,
      to: undefined,
    },
  );

  const componentType = computed(() => (props.to ? SwLink : 'button'));

  const computedClasses = computed(() => {
    const fabClass = props.fab ? btnStylingMapping.fab : '';
    const loadingClass = props.loading ? btnStylingMapping.loading : '';

    return !props.to
      ? `${btnStylingMapping.default} ${btnStylingMapping[props.variant]} ${
          btnStylingMapping[props.size]
        } ${fabClass} ${loadingClass}`
      : '';
  });
</script>

<template>
  <Component :is="componentType" :to="to" :class="computedClasses">
    <div class="flex flex-row items-center justify-center gap-x-1">
      <div v-if="slots.icon || props.loading">
        <SwLoading v-if="props.loading" class="text-sm" />
        <template v-else>
          <div v-if="props.fab" class="fab-icon">
            <slot name="icon"></slot>
          </div>
          <slot v-else name="icon"></slot>
        </template>
      </div>

      <slot v-if="!props.fab" />
    </div>

    <span
      v-if="badge !== undefined"
      class="border-border text-information rounded-4 absolute -right-1 -top-1 border bg-white px-1.5 py-1 text-[0.625rem] font-bold"
    >
      {{ badge }}
    </span>
  </Component>
</template>
<style>
  .fab-icon span {
    @apply text-xl;
  }
</style>
